/* Arrange Program
   2008/06/09 By GucciTech  Chojiro Higashiguchi

   LCD_function_G1.h
   Liquid Crystal Dsiplay SC1602BS-B

   Pin Layout
   RS    RC2
   R/W   GND
   E     RC3
   D4    RC4
   D5    RC5
   D6    RC6
   D7    RC7
*/

void LCD_write(char data, char RS)
{
   /* RC7, RC6, RC5, RC4, RC3, RC2, RC1, RC0 */
   /* DB7, DB6, DB5, DB4,   E,  RS,   x,   x */
   
   output_C(data & 0xF0);     // DB7, DB6, DB5, DB4
   
   if (RS == 1)
   {
      output_high(PIN_C2);    // RS -> 1
   }
   else
   {
      output_low(PIN_C2);     // RS -> 0
   }
   
   delay_us(1);               // > 40 ns
   output_high(PIN_C3);        // E -> 1
   delay_us(1);               // > 230 ns
   output_low(PIN_C3);         // E -> 0
}

void LCD_display(char code)
{
   LCD_write(code, 1);
   LCD_write(code << 4, 1);
   delay_us(50);              // > 40 us
}

void LCD_control(char code)
{
   LCD_write(code, 0);
   LCD_write(code << 4, 0);
   delay_us(50);              // > 40 us
}

void LCD_clear(void)
{
   LCD_write(0x01, 0);
   LCD_write(0x01 << 4, 0);
   delay_ms(2);               // > 1.64 ms
}

void LCD_init(void)
{
   delay_ms(20);              // > 15 ms
   LCD_write(0x30, 0);        // 8 bit mode
   delay_ms(5);               // > 4.1 ms
   LCD_write(0x30, 0);        // 8 bit mode
   delay_ms(5);               // > 100 us
   LCD_write(0x30, 0);        // 8 bit mode
   delay_ms(5);               // > 4.1 ms
   LCD_write(0x20, 0);        // 4 bit mode
   delay_ms(5);               // > 40 us
   LCD_control(0x28);         // function set
   LCD_control(0x08);         // display off
   LCD_control(0x0C);         // display on
   LCD_control(0x06);         // entry mode set
}
